/*
 * File:   App_Test.c
 * Author: dan1138
 *
 *                           PIC18F45K80
 *                 +------------:_:------------+
 *       VPP ->  1 : RE3/MCLR/VPP      PGD/RB7 : 40 <> PGD
 *           <>  2 : RA0/AN0           PGC/RB6 : 39 <> PGC
 *           <>  3 : RA1               PGM/RB5 : 38 <> 
 *           <>  4 : RA2                   RB4 : 37 <> 
 *           <>  5 : RA3                   RB3 : 36 <> 
 *           <>  6 : RA4                   RB2 : 35 <> 
 *           <>  7 : RA5                   RB1 : 34 <> 
 *           <>  8 : RE0                   RB0 : 33 <> 
 *           <>  9 : RE1                   VDD : 32 <- 5v0
 *           <> 10 : RE2                   VSS : 31 <- GND
 *       5v0 -> 11 : VDD                   RD7 : 30 <> LCD_D7
 *       GND -> 12 : VSS                   RD6 : 29 <> LCD_D6
 *            < 13 : RA7/OSC1              RD5 : 28 <> LCD_D5
 *           <- 14 : RA6/OSC2              RD4 : 27 <> LCD_D4
 *           <> 15 : RC0/SOSCO       RX/DT/RC7 : 26 <> 
 *           <> 16 : RC1/SOSCI       TX/CK/RC6 : 25 <> LCD_EN
 *           <> 17 : RC2/CCP1     SPI_MOSI/RC5 : 24 <> LCD_RW
 *           <> 18 : RC3/SPI_CLK  SPI_MISO/RC4 : 23 <> LCD_RS
 *           <> 19 : RD0                   RD3 : 22 <> 
 *           <> 20 : RD1                   RD2 : 21 <> 
 *                 +---------------------------:
 *                            DIP-40
 *
 *
 * Created on September 30, 2020, 12:50 PM
 */

#include "mcc_generated_files/mcc.h"
#include "App_Test.h"
#include "lcd.h"

void App_Init(void)
{
    LCD_Init();
    LCD_SetDDRamAddr(LINE_ONE);
    /*               0123456789.12345 */
    LCD_WriteString("LCD Test v1.0   ");
}

void App_Test(void) 
{
    unsigned char Symbol;
    unsigned char HexChar[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};

    App_Init();
    Symbol = 0;
    __delay_ms(500);
    LCD_SetDDRamAddr(LINE_ONE+15);
    LCD_WriteData(HexChar[Symbol>>4]);
    LCD_SetDDRamAddr(LINE_TWO);
    for(;;)
    {
        LCD_WriteData(Symbol);
        Symbol++;
        if((Symbol & 0x0F) == 0) 
        {
            __delay_ms(1000);
            LCD_SetDDRamAddr(LINE_ONE+15);
            LCD_WriteData(HexChar[Symbol>>4]);
            LCD_SetDDRamAddr(LINE_TWO);
        }
    }
}
