/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.6
        Device            :  PIC18F45K80
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.30 and above
        MPLAB 	          :  MPLAB X 5.40	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set LED_RA0 aliases
#define LED_RA0_TRIS                 TRISAbits.TRISA0
#define LED_RA0_LAT                  LATAbits.LATA0
#define LED_RA0_PORT                 PORTAbits.RA0
#define LED_RA0_ANS                  ANCON0bits.ANSEL0
#define LED_RA0_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define LED_RA0_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define LED_RA0_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define LED_RA0_GetValue()           PORTAbits.RA0
#define LED_RA0_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define LED_RA0_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define LED_RA0_SetAnalogMode()      do { ANCON0bits.ANSEL0 = 1; } while(0)
#define LED_RA0_SetDigitalMode()     do { ANCON0bits.ANSEL0 = 0; } while(0)

// get/set PGC aliases
#define PGC_TRIS                 TRISBbits.TRISB6
#define PGC_LAT                  LATBbits.LATB6
#define PGC_PORT                 PORTBbits.RB6
#define PGC_WPU                  WPUBbits.WPUB6
#define PGC_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define PGC_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define PGC_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define PGC_GetValue()           PORTBbits.RB6
#define PGC_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define PGC_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define PGC_SetPullup()          do { WPUBbits.WPUB6 = 1; } while(0)
#define PGC_ResetPullup()        do { WPUBbits.WPUB6 = 0; } while(0)

// get/set PGD aliases
#define PGD_TRIS                 TRISBbits.TRISB7
#define PGD_LAT                  LATBbits.LATB7
#define PGD_PORT                 PORTBbits.RB7
#define PGD_WPU                  WPUBbits.WPUB7
#define PGD_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define PGD_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define PGD_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define PGD_GetValue()           PORTBbits.RB7
#define PGD_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define PGD_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define PGD_SetPullup()          do { WPUBbits.WPUB7 = 1; } while(0)
#define PGD_ResetPullup()        do { WPUBbits.WPUB7 = 0; } while(0)

// get/set LCD_RS aliases
#define LCD_RS_TRIS                 TRISCbits.TRISC4
#define LCD_RS_LAT                  LATCbits.LATC4
#define LCD_RS_PORT                 PORTCbits.RC4
#define LCD_RS_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define LCD_RS_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define LCD_RS_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define LCD_RS_GetValue()           PORTCbits.RC4
#define LCD_RS_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define LCD_RS_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)

// get/set LCD_RW aliases
#define LCD_RW_TRIS                 TRISCbits.TRISC5
#define LCD_RW_LAT                  LATCbits.LATC5
#define LCD_RW_PORT                 PORTCbits.RC5
#define LCD_RW_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define LCD_RW_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define LCD_RW_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define LCD_RW_GetValue()           PORTCbits.RC5
#define LCD_RW_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define LCD_RW_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)

// get/set LCD_EN aliases
#define LCD_EN_TRIS                 TRISCbits.TRISC6
#define LCD_EN_LAT                  LATCbits.LATC6
#define LCD_EN_PORT                 PORTCbits.RC6
#define LCD_EN_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define LCD_EN_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define LCD_EN_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define LCD_EN_GetValue()           PORTCbits.RC6
#define LCD_EN_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define LCD_EN_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)

// get/set LCD_D4 aliases
#define LCD_D4_TRIS                 TRISDbits.TRISD4
#define LCD_D4_LAT                  LATDbits.LATD4
#define LCD_D4_PORT                 PORTDbits.RD4
#define LCD_D4_SetHigh()            do { LATDbits.LATD4 = 1; } while(0)
#define LCD_D4_SetLow()             do { LATDbits.LATD4 = 0; } while(0)
#define LCD_D4_Toggle()             do { LATDbits.LATD4 = ~LATDbits.LATD4; } while(0)
#define LCD_D4_GetValue()           PORTDbits.RD4
#define LCD_D4_SetDigitalInput()    do { TRISDbits.TRISD4 = 1; } while(0)
#define LCD_D4_SetDigitalOutput()   do { TRISDbits.TRISD4 = 0; } while(0)

// get/set LCD_D5 aliases
#define LCD_D5_TRIS                 TRISDbits.TRISD5
#define LCD_D5_LAT                  LATDbits.LATD5
#define LCD_D5_PORT                 PORTDbits.RD5
#define LCD_D5_SetHigh()            do { LATDbits.LATD5 = 1; } while(0)
#define LCD_D5_SetLow()             do { LATDbits.LATD5 = 0; } while(0)
#define LCD_D5_Toggle()             do { LATDbits.LATD5 = ~LATDbits.LATD5; } while(0)
#define LCD_D5_GetValue()           PORTDbits.RD5
#define LCD_D5_SetDigitalInput()    do { TRISDbits.TRISD5 = 1; } while(0)
#define LCD_D5_SetDigitalOutput()   do { TRISDbits.TRISD5 = 0; } while(0)

// get/set LCD_D6 aliases
#define LCD_D6_TRIS                 TRISDbits.TRISD6
#define LCD_D6_LAT                  LATDbits.LATD6
#define LCD_D6_PORT                 PORTDbits.RD6
#define LCD_D6_SetHigh()            do { LATDbits.LATD6 = 1; } while(0)
#define LCD_D6_SetLow()             do { LATDbits.LATD6 = 0; } while(0)
#define LCD_D6_Toggle()             do { LATDbits.LATD6 = ~LATDbits.LATD6; } while(0)
#define LCD_D6_GetValue()           PORTDbits.RD6
#define LCD_D6_SetDigitalInput()    do { TRISDbits.TRISD6 = 1; } while(0)
#define LCD_D6_SetDigitalOutput()   do { TRISDbits.TRISD6 = 0; } while(0)

// get/set LCD_D7 aliases
#define LCD_D7_TRIS                 TRISDbits.TRISD7
#define LCD_D7_LAT                  LATDbits.LATD7
#define LCD_D7_PORT                 PORTDbits.RD7
#define LCD_D7_SetHigh()            do { LATDbits.LATD7 = 1; } while(0)
#define LCD_D7_SetLow()             do { LATDbits.LATD7 = 0; } while(0)
#define LCD_D7_Toggle()             do { LATDbits.LATD7 = ~LATDbits.LATD7; } while(0)
#define LCD_D7_GetValue()           PORTDbits.RD7
#define LCD_D7_SetDigitalInput()    do { TRISDbits.TRISD7 = 1; } while(0)
#define LCD_D7_SetDigitalOutput()   do { TRISDbits.TRISD7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/